<script class='controller'>
    setTimeout(function() {

        /*           ACTUALIZAR CONTADORES               */
        $(document).off('click', "#updateCharts");
        $(document).on('click', '#updateCharts', function(e) {
            var userIntel = JSON.parse(window.localStorage.getItem("userIntel")),
                panelToShow = userIntel.panelUsuario,
                userId = $('#sidebarLoaded').attr('userIdPanel');
            $("#loading").fadeIn("fast", function() {
                showPanel(panelToShow, userId);
            });
        });

        /** CUANDO INICIA EL MODULO CARGAMOS LAS PRIMERAS TARJETAS */
        $('.anim1').velocity("transition.slideUpBigIn", {
            stagger: 250,
            complete: function() {
                $('#buscarDevol').focus();
            }
        });

        /** BUSCAMOS LA ORDEN DE DEVOLUCION POR EL BOTON O POR LA PISTOLA */
        $(document).off('click', ".buscarDevolBox button");
        $(document).on('click', '.buscarDevolBox button', function(e) {

            var devolVal = $(document).find('#buscarDevol').val(),
                carritoVal = $(document).find('#buscarCarrito').val();
            if (devolVal == '' || carritoVal == '') {
                $.growl.error({
                    message: "Debe llenar todos los campos"
                });
                return;
            }
            getThisDevol();
        });
        $(document).find('#buscarDevol').keypress(function(e) {
            if (e.which == 13) {

                var devolVal = $(document).find('#buscarDevol').val(),
                    carritoVal = $(document).find('#buscarCarrito').val();
                if (devolVal == '' || carritoVal == '') {
                    $.growl.error({
                        message: "Debe llenar todos los campos"
                    });
                    return;
                }
                getThisDevol();
            }
        });

        /** LE RESTAMOS 1 UNIDAD AL LISTADO SELECCIONADO */
        $(document).off('click', ".restarUnidad");
        $(document).on('click', '.restarUnidad', function(e) {

            var codigoBarrasDevuelto = $(this).parent().parent().parent().find('.codigoBarrasDevuelto').html(),
                unidTotales = $(this).parent().parent().parent().find('.unidTotales').html(),
                isListed = 0,
                unidXDevolver = $(this).parent().parent().parent().find('.unidXDevolver').html();

            var totalEscan = $('.unidadesEscaenadasTotal span').html();
            totalEscan = +totalEscan - 1;
            $('.unidadesEscaenadasTotal span').html(totalEscan);

            $(document).find('.listadoDevol tbody tr').each(function(i, n) {
                var codbarras = $(n).find('.codigoBarras').html(),
                    numlin = $(n).find('.numlin').html(),
                    supedido = $(n).find('.supedido').html(),
                    unidadesLeidas = $(n).find('.unidadesLeidas').html(),
                    unidades = $(n).find('.unidades').html();

                if (codbarras == codigoBarrasDevuelto && isListed == 0) {
                    isListed = 1
                    restantes = +unidadesLeidas - 1;
                    $(n).find('.unidadesLeidas').html(restantes.toFixed(0));
                    $(n).removeClass('fullyReadPicki');
                    $(n).slideDown('slow');
                    $(n).find('.card').removeClass('bg-info text-white');
                }

            });

            unidXDevolver--;
            if (unidXDevolver == 0) {
                $(this).parent().parent().parent().parent().remove();

                var cajasLeidas = cajasRead();
                $('.unidadesEscaenadasTotalCaja span').html(cajasLeidas.length);

                $(document).find('.listadoDevol tbody tr').each(function(i, n) {
                    var codbarras = $(n).find('.codigoBarras').html();

                    if (codbarras == codigoBarrasDevuelto && isListed == 0) {
                        $(n).removeClass('fullyReadPicki');
                        $(n).slideDown('slow');
                        $(n).find('.card').removeClass('bg-info text-white');
                    }

                });

                return;
            }
            var newPropor = (+unidXDevolver * 100) / +unidTotales;
            $(this).parent().parent().parent().find('.unidXDevolver').html(unidXDevolver);
            $(this).parent().parent().parent().find('.unidXDevolverPropor').attr('style', 'width: ' + newPropor.toFixed(0) + '%');
        });

        /** ELIMINAMOS EL LISTADO SELECCIONADO */
        $(document).off('click', ".eliminarUnidades");
        $(document).on('click', '.eliminarUnidades', function(e) {

            var codigoBarrasDevuelto = $(this).parent().parent().parent().find('.codigoBarrasDevuelto').html(),
                unidTotales = $(this).parent().parent().parent().find('.unidTotales').html(),
                isListed = 0,
                unidXDevolver = $(this).parent().parent().parent().find('.unidXDevolver').html();

            var totalEscan = $('.unidadesEscaenadasTotal span').html();
            totalEscan = +totalEscan - +unidXDevolver;
            $('.unidadesEscaenadasTotal span').html(totalEscan);

            $(this).parent().parent().parent().parent().remove();

            var cajasLeidas = cajasRead();
            $('.unidadesEscaenadasTotalCaja span').html(cajasLeidas.length);

            $(document).find('.listadoDevol tbody tr').each(function(i, n) {
                var codbarras = $(n).find('.codigoBarras').html(),
                    numlin = $(n).find('.numlin').html(),
                    supedido = $(n).find('.supedido').html(),
                    unidadesLeidas = $(n).find('.unidadesLeidas').html(),
                    unidades = $(n).find('.unidades').html();

                if (codbarras == codigoBarrasDevuelto && isListed == 0) {
                    isListed = 1;
                    var unidadesRestantes = +unidadesLeidas - +unidXDevolver;
                    $(n).find('.unidadesLeidas').html(unidadesRestantes);
                    $(n).removeClass('fullyReadPicki');
                    $(n).slideDown('slow');
                }

            });
            return;
        });
	 /**	$(document).off('change', "input[type=radio][name=caja-radios]");
        $(document).on('change', "input[type=radio][name=caja-radios]", function(e) {
            console.log(this.value);
            if (this.value == 'sincajamaster') {
                $(document).find('.cajamasterBoxInpG').slideUp('slow');
                $(document).find('#cajamasterBox').val('0000');
            } else if (this.value == 'cajamaster') {
                $(document).find('#cajamasterBox').val('');
                $(document).find('.cajamasterBoxInpG').slideDown('slow');
            }
        }); */

        /** GUARDAMOS LA  DEVOLUCION */
        $(document).off('click', "#saveND");
        $(document).on('click', '#saveND', function(e) {
			
			//alert("Accion iniciada");

            var rowsCount = 0,
                devoldetail = [],
                userId = $('#sidebarLoaded').attr('userIdPanel');
				
				
            // var idtransaccion = userId + userId + new Date();
			var idtransaccion = (Date.now());
           // idtransaccion = Math.abs(idtransaccion.hashCode());
            $(document).find('.porDevolInfoBox').each(function(i, n) {
                $(n).find('.thisReadDevol tbody tr').each(function(ii, nn) {

                    var devolRow = {};
                    devolRow.codarticulo = $(nn).find('.codarticuloRead').html();
                    devolRow.talla = $(nn).find('.tallaRead').html();
                    devolRow.color = $(nn).find('.colorRead').html();
                    devolRow.oldquantity = $(nn).find('.oldquantityRead').html();
                    devolRow.type = '30';
                    devolRow.barcode = $(nn).find('.barcodeRead').html();
                    devolRow.returnquantity = $(nn).find('.thisCantAcum').html();
                    devolRow.cajamas = $(nn).find('.cajMasRead').html();
                    devolRow.ubi = $(nn).find('.locatRead').html();
                    devolRow.doc = $(nn).find('.docRead').html();
                    devolRow.usuario = userId;
                    devolRow.carrito = $(nn).find('.carritoSerch').html();
					devolRow.idtransaccion = idtransaccion;
                    devolRow.idlinea = rowsCount;

                    devoldetail.push(devolRow);

                    rowsCount++;
                });
            });
			//alert("Variables iniciadas y seteadas");
            if (rowsCount > 0) {

                $(this).velocity("transition.slideUpOut", {
                    duration: 200,
                    complete: function() {
                        $('#saveNDFake').velocity("transition.slideUpIn", {
                            duration: 200,
                            complete: function() {
                                var formData = new FormData(),
                                    userId = $('#sidebarLoaded').attr('userIdPanel');
                                formData.append('userDevol', userId);
                                formData.append('devol', JSON.stringify(devoldetail));
                                formData.append('meth', 'saveNewRecepsTrals');
                                apiCall(formData, function(data) {
                                    console.log(data);
									//alert("Llamado al metodo");
									//alert(JSON.stringify(data));
                                    if (data.status == "saved") {
                                        $('.anim3,.porDevolInfoBox,#saveNDFake').velocity("transition.slideUpOut", {
                                            duration: 200,
                                            complete: function() {
                                                swal({
                                                    title: "Felicitaciones",
                                                    text: "Su Recepcion ha sido registrada exitosamente.",
                                                    type: "success",
                                                    showCancelButton: false,
                                                    confirmButtonText: 'Entendido',
                                                    cancelButtonText: 'salir'
                                                });
                                                $('.porDevolInfoBox').remove();
                                                $('.anim11,#saveND').velocity("transition.slideUpIn", {
                                                    duration: 200
                                                })
                                            }
                                        });
                                    } else {
                                        $('#saveNDFake').velocity("transition.slideUpOut", {
                                            duration: 200,
                                            complete: function() {
                                                swal({
                                                    title: "Lo Sentimos",
                                                    text: "Hubo un problema para guardar sus datos, intente de nuevo",
                                                    type: "error",
                                                    showCancelButton: false,
                                                    confirmButtonText: 'Entendido',
                                                    cancelButtonText: 'salir'
                                                });
                                                $('#saveND').velocity("transition.slideUpIn", {
                                                    duration: 200
                                                })
                                            }
                                        });
                                    }
                                });

                            }
                        });
                    }
                });
            } else {
                $.growl.error({
                    message: "No hay productos leidos para recibir"
                });
            }

        });

        /** GUARDAMOS LA  DEVOLUCION A CEDI*/
        $(document).off('click', "#saveNDCed");
        $(document).on('click', '#saveNDCed', function(e) {

            var rowsCount = 0,
                devoldetail = [],
                userId = $('#sidebarLoaded').attr('userIdPanel');

          //   var idtransaccion = userId + userId + new Date();
		  var idtransaccion = (Date.now());
          //  idtransaccion = Math.abs(idtransaccion.hashCode());
            $(document).find('.porDevolInfoBox').each(function(i, n) {
                $(n).find('.thisReadDevol tbody tr').each(function(ii, nn) {

                    var devolRow = {};
                    devolRow.codarticulo = $(nn).find('.codarticuloRead').html();
                    devolRow.talla = $(nn).find('.tallaRead').html();
                    devolRow.color = $(nn).find('.colorRead').html();
                    devolRow.oldquantity = $(nn).find('.oldquantityRead').html();
                    devolRow.type = '30';
                    devolRow.barcode = $(nn).find('.barcodeRead').html();
                    devolRow.returnquantity = $(nn).find('.thisCantAcum').html();
                    devolRow.cajamas = $(nn).find('.cajMasRead').html();
                    devolRow.ubi = $(nn).find('.locatRead').html();
                    devolRow.doc = $(nn).find('.docRead').html();
                    devolRow.usuario = userId;
                    devolRow.carrito = $(nn).find('.carritoSerch').html();
					devolRow.idtransaccion = idtransaccion;
                    devolRow.idlinea = rowsCount;

                    devoldetail.push(devolRow);

                    rowsCount++;
                });
            });

            if (rowsCount > 0) {

                $(this).velocity("transition.slideUpOut", {
                    duration: 200,
                    complete: function() {
                        $('#saveNDFake').velocity("transition.slideUpIn", {
                            duration: 200,
                            complete: function() {
                                var formData = new FormData(),
                                    userId = $('#sidebarLoaded').attr('userIdPanel');
                                formData.append('userDevol', userId);
                                formData.append('devol', JSON.stringify(devoldetail));
                                formData.append('meth', 'saveNewRecepsTralsCedi');
                                apiCall(formData, function(data) {
                                    console.log(data);
                                    if (data.status == "saved") {
                                        $('.anim3,.anim33,.porDevolInfoBox,#saveNDFake').velocity("transition.slideUpOut", {
                                            duration: 200,
                                            complete: function() {
                                                swal({
                                                    title: "Felicitaciones",
                                                    text: "Su Recepcion ha sido registrada exitosamente.",
                                                    type: "success",
                                                    showCancelButton: false,
                                                    confirmButtonText: 'Entendido',
                                                    cancelButtonText: 'salir'
                                                });
                                                $('.porDevolInfoBox').remove();
                                                $('.anim11,#saveNDCed').velocity("transition.slideUpIn", {
                                                    duration: 200
                                                })
                                            }
                                        });
                                    } else {
                                        $('#saveNDFake').velocity("transition.slideUpOut", {
                                            duration: 200,
                                            complete: function() {
                                                swal({
                                                    title: "Lo Sentimos",
                                                    text: "Hubo un problema para guardar sus datos, intente de nuevo",
                                                    type: "error",
                                                    showCancelButton: false,
                                                    confirmButtonText: 'Entendido',
                                                    cancelButtonText: 'salir'
                                                });
                                                $('#saveNDCed').velocity("transition.slideUpIn", {
                                                    duration: 200
                                                })
                                            }
                                        });
                                    }
                                });

                            }
                        });
                    }
                });
            } else {
                $.growl.error({
                    message: "No hay productos leidos para recibir"
                });
            }

        });

        enterSubm();
    }, 1000);

    /** OBTENEMOS LOS DATOS DE LA ORDEN DE DEVOLUCION */
    function getThisDevol() {
        $('.searchingBtn').html('<i class="fa fa-spinner fa-spin"></i>');
        var devolVal = $(document).find('#buscarDevol').val(),
            carritoVal = $(document).find('#buscarCarrito').val(),
            formData = new FormData();
        formData.append('devolVal', devolVal);
        formData.append('carritoVal', carritoVal);
        formData.append('meth', 'consultarRecepTrasl');
        apiCall(formData, function(data) {
            console.log(data);
            $('.searchingBtn').html('<i class="fa fa-search"></i>');
            if (data.rows.length > 0) {
                $('.anim3').velocity("transition.slideUpBigOut", {
                    duration: 200,
                    complete: function() {
                        var code = '';
                        $('.listadoDevol tbody').html(code);
                        $('.ordenTitleNumbr').html(devolVal);
                        for (i = 0; i < data.rows.length; i++) {
                            $('.listadoDevol tbody').append(' <tr class="thisDevolProd">' +
                                '<td class="codArticulo" data-valtype="codArticulo">' + data.rows[i][1] + '</td>' +
                                '<td class="codigoBarras" data-valtype="codigoBarras">' + data.rows[i][6] + '</td> ' +
                                '<td class="offscreen cBar3" data-valtype="cBar3">' + data.rows[i][7] + '</td> ' +
                                '<td class="cajaMaster" data-valtype="cajaMaster">000</td> ' +
                                '<td class="ubicacion" data-valtype="ubicacion">000</td> ' +
                                '<td class="unidadesTotales" data-valtype="unidadesTotales">' + data.rows[i][8] + '</td> ' +
                                '<td class="unidadesLeidas" data-valtype="unidadesLeidas">0</td> ' +
                                '<td class="offscreen talla" data-valtype="talla">' + data.rows[i][4] + '</td> ' +
                                '<td class="offscreen color" data-valtype="color">' + data.rows[i][5] + '</td> ' +
                                '<td class="offscreen suPedido" data-valtype="suPedido">' + data.rows[i][0] + '</td> ' +
                                '<td class="offscreen carritoSerch" data-valtype="carritoSerch">' + carritoVal + '</td> ' +
								'<td class="offscreen codigoBarras2" data-valtype="codigoBarras2">' + data.rows[i][9] + '</td> ' +
                                ' </tr>');
                        }
                        $('.anim11').velocity("transition.slideUpBigOut", {
                            stagger: 250,
                            complete: function() {
                                $('.anim3').velocity("transition.slideUpBigIn", {
                                    stagger: 250,
                                    complete: function() {
                                        $('#cajamasterBox').focus();
                                    }
                                });
                            }
                        });
                    }
                });
            } else {
                $.growl.error({
                    message: "No existen documentos por procesar"
                });
                return;
            }
        });
    }

    /** AL LEER CON PISTOLA UN CODIGO DE BARRA */
    function getThisProd() {
        var codbar = $(document).find('#productoBox').val(),
            isInvoked = 0,
            isListed = 0,
            isPresent = 0;
        $(document).find('.listadoDevol tbody tr').not('.fullyReadPicki').each(function(i, n) {
            var codigoBarras = $(n).find('.codigoBarras').html(),
                cBar3 = $(n).find('.cBar3').html(),
				codigoBarras2 = $(n).find('.codigoBarras2').html(),
                codarticuloRead = $(n).find('.codArticulo').html(),
                tallaRead = $(n).find('.talla').html(),
                colorRead = $(n).find('.color').html(),
                docRead = $(n).find('.suPedido').html(),
                carritoSerch = $(n).find('.carritoSerch').html(),
                leidasUnidades = $(n).find('.unidadesLeidas').html(),
                totalUnidades = $(n).find('.unidadesTotales').html();

            if ((codigoBarras == codbar) || (codigoBarras2 == codbar) || (cBar3 == codbar))  {
                isPresent = 1;
                $(document).find('.porDevolInfoBox').not('.cajaMasterCard').each(function(ii, nn) {
                    var codigoBarrasDevuelto = $(nn).find('.codigoBarrasDevuelto').html();
                    if (codigoBarras == codigoBarrasDevuelto) {
                        isInvoked = 1;
                        var unidXDevolver = $(nn).find('.unidXDevolver').html();
                        var unidTotales = $(nn).find('.unidTotales').html();
						var ubimanual = $(document).find('#locationBox').val();
                        if (+unidXDevolver < +unidTotales) {
                            unidXDevolver++;
                            leidasUnidades++;
                            var newPropor = (+unidXDevolver * 100) / +unidTotales
                            $(nn).find('.unidXDevolver').html(unidXDevolver);
                            $(n).find('.unidadesLeidas').html(leidasUnidades);
                            $(nn).find('.thisCantAcum').html(unidXDevolver);
                            $(nn).find('.unidXDevolverPropor').attr('style', 'width: ' + newPropor.toFixed(0) + '%');
                            if (+unidXDevolver == +unidTotales) {
                                $(nn).find('.card').addClass('bg-info text-white');
                                $(n).addClass('fullyReadPicki');
                                $(n).slideUp('slow');
                            }

                            var totalEscan = $('.unidadesEscaenadasTotal span').html();
                            totalEscan++;
                            $('.unidadesEscaenadasTotal span').html(totalEscan);
                        } else {
                            $.growl.error({
                                message: "No puedes exceder el límite de la Orden"
                            });
                        }
                    }
                });
                if (isInvoked == 0) {
                    var fullCard = '';
                    totalUnidades = +totalUnidades - +leidasUnidades;
                    if (totalUnidades == 1) {
                        fullCard = 'bg-info text-white';
                        $(n).addClass('fullyReadPicki');
                        $(n).slideUp('slow');
                    }
                    var newPropor = 100 / +totalUnidades;
                    var invoke = `
                        <div class="col-sm-12 col-lg-12 col-xl-6 porDevolInfoBox">
                            <div class="card anim cod_` + codigoBarras + `  ` + fullCard + `">
                                <div class="card-header">
                                    <div class="card-title"><i class="fa fa-barcode "></i> <strong class=" codigoBarrasDevuelto">` + codigoBarras + `</strong></div>
                                    <div class="card-options ">
                                                            <span class="btn btn-info mr30 float-left restarUnidad"><i class="fa fa-minus"></i> </span> 
                                        <span class="btn btn-join text-white float-left pull-left mr10 eliminarUnidades"><i class="fa fa-times  "></i> </span>
                                    </div>
                                </div>
                                <div class="table-responsive">
                                    <table class="table table-bordered border-top card-table table-vcenter text-nowrap table-primary thisReadDevol anim">
                                        <thead class="bg-info text-white text-center">
                                            <tr>
                                                <th class="text-white offscreen">Ubicacion</th>
                                                <th class="text-white offscreen">Caja Master</th>
                                                <th class="text-white offscreen">Cantidad</th>
                                                <th class="offscreen">codarticulo</th>
                                                <th class="offscreen">talla</th>
                                                <th class="offscreen">color</th>
                                                <th class="offscreen">oldquantity</th>
                                                <th class="offscreen">barcode</th>
                                                <th class="offscreen">doc</th>
                                                <th class="offscreen">carrito</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            <tr>
                                                <td class="text-dark locatRead text-center offscreen">0000</td>
                                                <td class="text-dark cajMasRead text-center">0000</td>
                                                <td class="text-dark thisCantAcum text-center">1</td>
                                                <td class="offscreen codarticuloRead text-center">` + codarticuloRead + `</td>
                                                <td class="offscreen tallaRead text-center">` + tallaRead + `</td>
                                                <td class="offscreen colorRead text-center">` + colorRead + `</td>
                                                <td class="offscreen oldquantityRead text-center">` + totalUnidades + `</td>
                                                <td class="offscreen barcodeRead text-center">` + codigoBarras + `</td>
                                                <td class="offscreen docRead text-center">` + docRead + `</td>
                                                <td class="offscreen carritoSerch text-center">` + carritoSerch + `</td>
                                            </tr>
                                        </tbody>
                                    </table>
                                    <div class="offscreen "></div>
                                </div>
                                <div class="card-body">
                                    <div class="row">
                                        <div class="col text-center">
                                            <label class="tx-12">Unidades Totales</label>
                                            <h2 class="font-weight-normal unidTotales">` + totalUnidades + `</h2>
                                        </div>
                                        <div class="col border-left text-center">
                                            <label class="tx-12">Recibidas</label>
                                            <h2 class="font-weight-normal unidXDevolver">1</h2>
                                        </div>
                                    </div>
                                    <div class="progress mt-4">
                                        <div class="progress-bar progress-bar-striped progress-bar-animated bg-join unidXDevolverPropor" style="width: ` + newPropor + `%"></div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        `;

                    $(invoke).insertAfter('.readerPistolUnitBox');
                    $('.cod_' + codigoBarras).velocity("transition.slideUpBigIn", {
                        stagger: 250
                    });

                    var totalEscan = $('.unidadesEscaenadasTotal span').html();
                    totalEscan++;
                    $('.unidadesEscaenadasTotal span').html(totalEscan);

                    leidasUnidades++;
                    $(n).find('.unidadesLeidas').html(leidasUnidades);
                }
            }

            if ('123456789000' == codbar) {
                isPresent = 1;
                $(document).find('.porDevolInfoBox').not('.cajaMasterCard').each(function(ii, nn) {
                    var codigoBarrasDevuelto = $(nn).find('.codigoBarrasDevuelto').html();
					var ubimanual = $(document).find('#locationBox').val();
                    if (cBar3 == codigoBarrasDevuelto) {
                        isInvoked = 1;
                        var unidXDevolver = $(nn).find('.unidXDevolver').html();
                        if (+unidXDevolver < +totalUnidades) {
                            unidXDevolver++;
                            var newPropor = (+unidXDevolver * 100) / +totalUnidades
                            $(nn).find('.unidXDevolver').html(unidXDevolver);
                            $(n).find('.unidadesLeidas').html(unidXDevolver);
                            $(nn).find('.thisCantAcum').html(unidXDevolver);
                            $(nn).find('.unidXDevolverPropor').attr('style', 'width: ' + newPropor.toFixed(0) + '%');
                            if (+unidXDevolver == +totalUnidades) {
                                $(nn).find('.card').addClass('bg-info text-white');
                            }

                            var totalEscan = $('.unidadesEscaenadasTotal span').html();
                            totalEscan++;
                            $('.unidadesEscaenadasTotal span').html(totalEscan);
                        } else {
                            $.growl.error({
                                message: "No puedes exceder el límite de la Orden"
                            });
                        }
                    }
                });
                if (isInvoked == 0) {
                    $(n).find('.unidadesLeidas').html('1');
                    var newPropor = 100 / +totalUnidades;
                    var invoke = `
                        <div class="col-sm-12 col-lg-12 col-xl-6 porDevolInfoBox">
                            <div class="card anim cod_` + cBar3 + `">
                                <div class="card-header">
                                    <div class="card-title"><i class="fa fa-barcode "></i> <strong class=" codigoBarrasDevuelto">` + cBar3 + `</strong></div>
                                    <div class="card-options ">
                                                            <span class="btn btn-info mr30 float-left restarUnidad"><i class="fa fa-minus"></i> </span> 
                                        <span class="btn btn-join text-white float-left pull-left mr10 eliminarUnidades"><i class="fa fa-times  "></i> </span>
                                    </div>
                                </div>
                                <div class="table-responsive">
                                    <table class="table table-bordered border-top card-table table-vcenter text-nowrap table-primary thisReadDevol anim">
                                        <thead class="bg-info text-white text-center">
                                            <tr>
                                                <th class="text-white offscreen">Ubicacion</th>
                                                <th class="text-white offscreen">Caja Master</th>
                                                <th class="text-white offscreen">Cantidad</th>
                                                <th class="offscreen">codarticulo</th>
                                                <th class="offscreen">talla</th>
                                                <th class="offscreen">color</th>
                                                <th class="offscreen">oldquantity</th>
                                                <th class="offscreen">barcode</th>
                                                <th class="offscreen">doc</th>
                                                <th class="offscreen">carrito</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            <tr>
                                                <td class="text-dark locatRead text-center offscreen">0000</td>
                                                <td class="text-dark cajMasRead text-center">0000</td>
                                                <td class="text-dark thisCantAcum text-center">1</td>
                                                <td class="offscreen codarticuloRead text-center">` + codarticuloRead + `</td>
                                                <td class="offscreen tallaRead text-center">` + tallaRead + `</td>
                                                <td class="offscreen colorRead text-center">` + colorRead + `</td>
                                                <td class="offscreen oldquantityRead text-center">` + totalUnidades + `</td>
                                                <td class="offscreen barcodeRead text-center">` + cBar3 + `</td>
                                                <td class="offscreen docRead text-center">` + docRead + `</td>
                                                <td class="offscreen carritoSerch text-center">` + carritoSerch + `</td>
                                            </tr>
                                        </tbody>
                                    </table>
                                    <div class="offscreen "></div>
                                </div>
                                <div class="card-body">
                                    <div class="row">
                                        <div class="col text-center">
                                            <label class="tx-12">Unidades Totales</label>
                                            <h2 class="font-weight-normal unidTotales">` + totalUnidades + `</h2>
                                        </div>
                                        <div class="col border-left text-center">
                                            <label class="tx-12">Recibidas</label>
                                            <h2 class="font-weight-normal unidXDevolver">1</h2>
                                        </div>
                                    </div>
                                    <div class="progress mt-4">
                                        <div class="progress-bar progress-bar-striped progress-bar-animated bg-join unidXDevolverPropor" style="width: ` + newPropor + `%"></div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        `;

                    $(invoke).insertAfter('.readerPistolBox');
                    $('.cod_' + cBar3).velocity("transition.slideUpBigIn", {
                        stagger: 250
                    });

                    var totalEscan = $('.unidadesEscaenadasTotal span').html();
                    totalEscan++;
                    $('.unidadesEscaenadasTotal span').html(totalEscan);
                }
            }
        });
        if (isPresent == 0) {
            $.growl.error({
                message: "Este producto no se encuentra en la Orden "
            });
        }
        $(document).find('#productoBox').val('');
        $(document).find('#productoBox').focus();

    }

    /** FUNCIONALIDAD DE LOS INPUT */
    function enterSubm() {
        $('.cajamasterBoxInp').keypress(function(e) {
            if (e.which == 13) {
                $('.productoBoxInp').val('');
                $('.productoBoxInp').focus();
            }
        });
        $('.productoBoxInp').keypress(function(e) {
            if (e.which == 13) {
                var devolVal = $(document).find('#productoBox').val(),
                    calaVal = $(document).find('#cajamasterBox').val(); //,
                //locatVal = $(document).find('#locationBox').val();
                if (devolVal == '' || calaVal == '' /* || locatVal == ''*/ ) {
                    $.growl.error({
                        message: "Debe llenar todos los campos"
                    });
                    return;
                }
                getThisProd();
            }
        });

        //$(document).find('#locationBox').val('0000');
        $(document).off('change', "input[type=radio][name=caja-radios]");
        $(document).on('change', "input[type=radio][name=caja-radios]", function(e) {
            console.log(this.value);
            if (this.value == 'sincajamaster') {
                $(document).find('#locationBox').val('');
                $(document).find('.cajamasterBoxInpG').slideUp('slow');
                $(document).find('.locationBoxInpG').slideDown('slow');
                $(document).find('#cajamasterBox').val('0000');
                $('.locationBoxInp').focus();
            } else if (this.value == 'cajamaster') {
                $(document).find('#cajamasterBox').val('');
                $(document).find('.cajamasterBoxInpG').slideDown('slow');
                $(document).find('.locationBoxInpG').slideUp('slow');
                $(document).find('#locationBox').val('0000');
                $('.cajamasterBoxInp').focus();
            }
        });

        /** AL PRESIONAR EL BOTON EL CODIGO DE BARRA Y LO CARGAMOS AL LISTADO */
        $(document).off('click', ".readerPistolBox button.envi");
        $(document).on('click', '.readerPistolBox button.envi', function(e) {

            var devolVal = $(document).find('#productoBox').val(),
                calaVal = $(document).find('#cajamasterBox').val(); //,
            //locatVal = $(document).find('#locationBox').val();
            if (devolVal == '' || calaVal == '' /* || locatVal == ''*/ ) {
                $.growl.error({
                    message: "Debe llenar todos los campos"
                });
                return;
            }
            getThisProd();
        });

        /*           ACTUALIZAR CAJA O INDIVIDUAL               */
        $(document).off('click', ".leerCajaCompleta");
        $(document).on('click', '.leerCajaCompleta', function(e) {
            $('.readerPistolBox').velocity("transition.slideLeftBigOut", {
                duration: 200,
                complete: function() {
                    $('.readerPistolUnitBox').velocity("transition.slideLeftBigIn", {
                        duration: 200
                    });
                }
            });
        });
        $(document).off('click', ".leerProductosIndividuales");
        $(document).on('click', '.leerProductosIndividuales', function(e) {
            $('.readerPistolUnitBox').velocity("transition.slideLeftBigOut", {
                duration: 200,
                complete: function() {
                    $('.readerPistolBox').velocity("transition.slideLeftBigIn", {
                        duration: 200
                    });
                }
            });
        });

        $(document).off('click', ".readerPistolUnitBox button.enviUnit");
        $(document).on('click', '.readerPistolUnitBox button.enviUnit', function(e) {

            var cajaVal = $(document).find('#productoBoxUnit').val();
            if (cajaVal == '') {
                $.growl.error({
                    message: "Debe llenar todos los campos"
                });
                return;
            }
            getThisCaja();
        });
        $('.productoBoxUnitInp').keypress(function(e) {
            if (e.which == 13) {
                var cajaVal = $(document).find('#productoBoxUnit').val();
                if (cajaVal == '') {
                    $.growl.error({
                        message: "Debe llenar todos los campos"
                    });
                    return;
                }
                getThisCaja();
            }
        });

        /*           ACTUALIZAR CAJA O INDIVIDUAL    CEDI           */
        $(document).off('click', ".leerCajaCompletaCedi");
        $(document).on('click', '.leerCajaCompletaCedi', function(e) {
            $('.readerPistolBox, .saveBoxBtn').velocity("transition.slideLeftBigOut", {
                duration: 200,
                complete: function() {
                    $('.readerPistolUnitBoxCedi, .cediBoxSave').velocity("transition.slideLeftBigIn", {
                        duration: 200
                    });
                }
            });
        });
        $(document).off('click', ".leerProductosIndividualesCedi");
        $(document).on('click', '.leerProductosIndividualesCedi', function(e) {
            $('.readerPistolUnitBoxCedi, .cediBoxSave').velocity("transition.slideLeftBigOut", {
                duration: 200,
                complete: function() {
                    $('.readerPistolBox, .saveBoxBtn').velocity("transition.slideLeftBigIn", {
                        duration: 200
                    });
                }
            });
        });

        $(document).off('click', " button.enviUnitCedi");
        $(document).on('click', ' button.enviUnitCedi', function(e) {
            var cajaVal = $(document).find('#productoBoxUnitCedi').val();
            var locationCediVal = $(document).find('#ubicBoxUnitCedi').val();
            if (cajaVal == '' || locationCediVal == '') {
                $.growl.error({
                    message: "Debe llenar todos los campos"
                });
                return;
            }
            getThisCajaCedi();
        });
        $('#productoBoxUnitCedi').keypress(function(e) {
            if (e.which == 13) {
                var cajaVal = $(document).find('#productoBoxUnitCedi').val();
                var locationCediVal = $(document).find('#ubicBoxUnitCedi').val();
                if (cajaVal == '' || locationCediVal == '') {
                    $.growl.error({
                        message: "Debe llenar todos los campos"
                    });
                    return;
                }
                getThisCajaCedi();
            }
        });

    }

    /** OBTENEMOS LOS DATOS DE LA CAJA MASTER Y TODOS SUS PRODUCTOS */
    function getThisCaja() {
        $('.refreshPageIcon').addClass('fa-spin');
        var cajaVal = $(document).find('#productoBoxUnit').val(),
		ubimanual = $(document).find('#locationBox').val(),
            formData = new FormData(),
            supedido = 0,
            isInvoked = 0;
        $(document).find('.listadoDevol tbody tr').each(function(i, n) {
            supedido = $(n).find('.suPedido').html();
        });

        var cajasLeidas = cajasRead();
        if (cajasLeidas.includes(cajaVal)) {
            $.growl.error({
                message: "Esta caja ya fue capturada, no puede repetir la caja en el mismo pedido"
            });
            $(document).find('#productoBoxUnit').val('');
            $(document).find('#productoBoxUnit').focus();
            return;
        }

        formData.append('cajaVal', cajaVal);
        formData.append('supedido', supedido);
        formData.append('meth', 'consultarCajaMasterTrasl');
        apiCall(formData, function(data) {
            console.log(data);
            $('.refreshPageIcon').removeClass('fa-spin');
            if (data.rows.length > 0) {

                var totalEscan = $('.unidadesEscaenadasTotalCaja span').html();
                var wasAqui = 0;
                var isAqui = 0;
                $(data.rows).each(function(i, n) {
                    var suPedido = 0,
                        countedRow = 0;
                    isAqui = 0;

                    var totalUnidades = 0,
                        carritoSerch = 0;

                    $(document).find('.listadoDevol tbody tr').each(function(ii, nn) {
                        var codigoBarras = $(nn).find('.codigoBarras').html(),
                            cBar3 = $(nn).find('.cBar3').html(),
                            codarticuloRead = $(nn).find('.codArticulo').html(),
                            tallaRead = $(nn).find('.talla').html(),
                            colorRead = $(nn).find('.color').html(),
                            leidasUnidades = $(nn).find('.unidadesLeidas').html();

                        suPedido = $(nn).find('.suPedido').html();

                        if (isAqui == 0) {
                            if (n[6] == codigoBarras || n[6] == cBar3) {
                                totalUnidades = $(nn).find('.unidadesTotales').html();
                                var totalLeidas = +leidasUnidades + +n[7];
                                if (totalLeidas > totalUnidades) {
                                    $.growl.error({
                                        message: "No puedes exceder el límite de la Orden"
                                    });
                                    wasAqui = 1;
                                    return;
                                }
                                isAqui = 1;
                                $(nn).find('.unidadesLeidas').html(totalLeidas);
                                carritoSerch = $(nn).find('.carritoSerch').html();
                                if (totalLeidas == totalUnidades) {
                                    $(nn).addClass('fullyReadPicki');
                                    $(nn).slideUp('slow');
                                }
                            }
                        }
                    });

                    if (isAqui == 1) {
                        if (isInvoked == 0) {
                            var newPropor = 100
                            var invoke = `
                                            <div class="col-sm-12 col-lg-12 col-xl-6 porDevolInfoBox cajaMasterCard" data-codcaja="` + cajaVal + `">
                                                <div class="card anim cod_` + n[6] + ` bg-info text-white">
                                                    <div class="card-header">
                                                        <div class="card-title"><i class="fa fa-barcode "></i> <strong class=" codigoBarrasDevuelto">` + n[6] + `</strong></div>
                                                        <div class="card-options ">
                                                            <span class="btn btn-info mr30 float-left restarUnidad"><i class="fa fa-minus"></i> </span> 
                                                            <span class="btn btn-info text-white float-left pull-left mr10 "><i class="fa fa-copyright  "></i> </span>
                                                            <span class="btn btn-join text-white float-left pull-left mr10 eliminarUnidades"><i class="fa fa-times  "></i> </span>
                                                        </div>
                                                    </div>
                                                    <div class="table-responsive">
                                                        <table class="table table-bordered border-top card-table table-vcenter text-nowrap table-primary thisReadDevol anim">
                                                            <thead class="bg-info text-white text-center">
                                                                <tr>
                                                                    <th class="text-white">Ubicacion</th>
                                                                    <th class="text-white">Caja Master</th>
                                                                    <th class="text-white">Cantidad</th>
                                                                    <th class="offscreen">codarticulo</th>
                                                                    <th class="offscreen">talla</th>
                                                                    <th class="offscreen">color</th>
                                                                    <th class="offscreen">oldquantity</th>
                                                                    <th class="offscreen">barcode</th>
                                                                    <th class="offscreen">doc</th>
                                                                </tr>
                                                            </thead>
                                                            <tbody>
                                                                <tr>
                                                                    <td class="text-dark locatRead text-center">0000</td>
                                                                    <td class="text-dark cajMasRead text-center">` + n[8] + `</td>
                                                                    <td class="text-dark thisCantAcum text-center">` + n[7] + `</td>
                                                                    <td class="offscreen codarticuloRead text-center">` + n[1] + `</td>
                                                                    <td class="offscreen tallaRead text-center">` + n[2] + `</td>
                                                                    <td class="offscreen colorRead text-center">` + n[3] + `</td>
                                                                    <td class="offscreen oldquantityRead text-center">` + n[7] + `</td>
                                                                    <td class="offscreen barcodeRead text-center">` + n[6] + `</td>
                                                                    <td class="offscreen docRead text-center">` + suPedido + `</td>
                                                                    <td class="offscreen carritoSerch text-center">` + carritoSerch + `</td>
                                                                </tr>
                                                            </tbody>
                                                        </table>
                                                        <div class="offscreen "></div>
                                                    </div>
                                                    <div class="card-body">
                                                        <div class="row">
                                                            <div class="col text-center">
                                                                <label class="tx-12">Unidades Totales</label>
                                                                <h2 class="font-weight-normal unidTotales">` + n[7] + `</h2>
                                                            </div>
                                                            <div class="col border-left text-center">
                                                                <label class="tx-12">A Recepcionar</label>
                                                                <h2 class="font-weight-normal unidXDevolver">` + n[7] + `</h2>
                                                            </div>
                                                        </div>
                                                        <div class="progress mt-4">
                                                            <div class="progress-bar progress-bar-striped progress-bar-animated bg-join unidXDevolverPropor" style="width: ` + newPropor + `%"></div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                            `;


                            var totalEscan = $('.unidadesEscaenadasTotal span').html();
                            totalEscan = +totalEscan + +n[7];
                            $('.unidadesEscaenadasTotal span').html(totalEscan);

                            $(invoke).insertAfter('.readerPistolUnitBox');
                            $('.cod_' + n[6]).velocity("transition.slideUpBigIn", {
                                stagger: 250
                            });
                        }
                    }
                });
                if (isAqui == 0 && wasAqui == 0) {
                    $.growl.error({
                        message: "Los codigos de la caja no coinciden con los del pedido."
                    });
                }

                var cajasLeidas = cajasRead();
                $('.unidadesEscaenadasTotalCaja span').html(cajasLeidas.length);
            } else {
                $.growl.error({
                    message: "Esta caja no contiene productos registrados"
                });
                return;
            }

            $(document).find('#productoBoxUnit').val('');
            $(document).find('#productoBoxUnit').focus();
        });
    }

    /* LEEMOS LAS CAJAS QUE HAN SIDO PITADAS */
    function cajasRead() {
        var cajasLeidas = [];
        $(document).find('.porDevolInfoBox').each(function(ii, nn) {
            var codCaja = $(nn).attr('data-codcaja');
            if (!cajasLeidas.includes(codCaja)) {
                cajasLeidas.push(codCaja);
            }
        });
        return cajasLeidas;
    }

    /** OBTENEMOS LOS DATOS DE LA CAJA MASTER Y TODOS SUS PRODUCTOS METODO CEDI*/
    function getThisCajaCedi() {
        $('.refreshPageIcon').addClass('fa-spin');
        var locationCediVal = $(document).find('#ubicBoxUnitCedi').val();
        var cajaVal = $(document).find('#productoBoxUnitCedi').val(),
            formData = new FormData(),
            supedido = 0,
            isInvoked = 0;
        $(document).find('.listadoDevol tbody tr').each(function(i, n) {
            supedido = $(n).find('.suPedido').html();
        });

        var cajasLeidas = cajasRead();
        if (cajasLeidas.includes(cajaVal)) {
            $.growl.error({
                message: "Esta caja ya fue capturada, no puede repetir la caja en el mismo pedido"
            });
            $(document).find('#productoBoxUnit').val('');
            $(document).find('#productoBoxUnit').focus();
            return;
        }

        formData.append('cajaVal', cajaVal);
        formData.append('supedido', supedido);
        formData.append('meth', 'consultarCajaMasterTrasl');
        apiCall(formData, function(data) {
            console.log(data);
            $('.refreshPageIcon').removeClass('fa-spin');
            if (data.rows.length > 0) {

                var totalEscan = $('.unidadesEscaenadasTotalCaja span').html();
                var wasAqui = 0;
                var isAqui = 0;
                $(data.rows).each(function(i, n) {
                    var suPedido = 0,
                        countedRow = 0;
                    isAqui = 0;

                    var totalUnidades = 0,
                        carritoSerch = 0;

                    $(document).find('.listadoDevol tbody tr').each(function(ii, nn) {
                        var codigoBarras = $(nn).find('.codigoBarras').html(),
                            cBar3 = $(nn).find('.cBar3').html(),
                            codarticuloRead = $(nn).find('.codArticulo').html(),
                            tallaRead = $(nn).find('.talla').html(),
                            colorRead = $(nn).find('.color').html(),
                            leidasUnidades = $(nn).find('.unidadesLeidas').html();

                        suPedido = $(nn).find('.suPedido').html();

                        if (isAqui == 0) {
                            if (n[6] == codigoBarras || n[6] == cBar3) {
                                totalUnidades = $(nn).find('.unidadesTotales').html();
                                var totalLeidas = +leidasUnidades + +n[7];
                                if (totalLeidas > totalUnidades) {
                                    $.growl.error({
                                        message: "No puedes exceder el límite de la Orden"
                                    });
                                    wasAqui = 1;
                                    return;
                                }
                                isAqui = 1;
                                $(nn).find('.unidadesLeidas').html(totalLeidas);
                                carritoSerch = $(nn).find('.carritoSerch').html();
                                if (totalLeidas == totalUnidades) {
                                    $(nn).addClass('fullyReadPicki');
                                    $(nn).slideUp('slow');
                                }
                            }
                        }
                    });

                    if (isAqui == 1) {
                        if (isInvoked == 0) {
                            var newPropor = 100
                            var invoke = `
                                            <div class="col-sm-12 col-lg-12 col-xl-6 porDevolInfoBox cajaMasterCard" data-codcaja="` + cajaVal + `">
                                                <div class="card anim cod_` + n[6] + ` bg-info text-white">
                                                    <div class="card-header">
                                                        <div class="card-title"><i class="fa fa-barcode "></i> <strong class=" codigoBarrasDevuelto">` + n[6] + `</strong></div>
                                                        <div class="card-options ">
                                                            <span class="btn btn-info mr30 float-left restarUnidad"><i class="fa fa-minus"></i> </span> 
                                                            <span class="btn btn-info text-white float-left pull-left mr10 "><i class="fa fa-copyright  "></i> </span>
                                                            <span class="btn btn-join text-white float-left pull-left mr10 eliminarUnidades"><i class="fa fa-times  "></i> </span>
                                                        </div>
                                                    </div>
                                                    <div class="table-responsive">
                                                        <table class="table table-bordered border-top card-table table-vcenter text-nowrap table-primary thisReadDevol anim">
                                                            <thead class="bg-info text-white text-center">
                                                                <tr>
                                                                    <th class="text-white">Ubicacion</th>
                                                                    <th class="text-white">Caja Master</th>
                                                                    <th class="text-white">Cantidad</th>
                                                                    <th class="offscreen">codarticulo</th>
                                                                    <th class="offscreen">talla</th>
                                                                    <th class="offscreen">color</th>
                                                                    <th class="offscreen">oldquantity</th>
                                                                    <th class="offscreen">barcode</th>
                                                                    <th class="offscreen">doc</th>
                                                                </tr>
                                                            </thead>
                                                            <tbody>
                                                                <tr>
                                                                    <td class="text-dark locatRead text-center">` + locationCediVal + `</td>
                                                                    <td class="text-dark cajMasRead text-center">` + n[8] + `</td>
                                                                    <td class="text-dark thisCantAcum text-center">` + n[7] + `</td>
                                                                    <td class="offscreen codarticuloRead text-center">` + n[1] + `</td>
                                                                    <td class="offscreen tallaRead text-center">` + n[2] + `</td>
                                                                    <td class="offscreen colorRead text-center">` + n[3] + `</td>
                                                                    <td class="offscreen oldquantityRead text-center">` + n[7] + `</td>
                                                                    <td class="offscreen barcodeRead text-center">` + n[6] + `</td>
                                                                    <td class="offscreen docRead text-center">` + suPedido + `</td>
                                                                    <td class="offscreen carritoSerch text-center">` + carritoSerch + `</td>
                                                                </tr>
                                                            </tbody>
                                                        </table>
                                                        <div class="offscreen "></div>
                                                    </div>
                                                    <div class="card-body">
                                                        <div class="row">
                                                            <div class="col text-center">
                                                                <label class="tx-12">Unidades Totales</label>
                                                                <h2 class="font-weight-normal unidTotales">` + n[7] + `</h2>
                                                            </div>
                                                            <div class="col border-left text-center">
                                                                <label class="tx-12">A Recepcionar</label>
                                                                <h2 class="font-weight-normal unidXDevolver">` + n[7] + `</h2>
                                                            </div>
                                                        </div>
                                                        <div class="progress mt-4">
                                                            <div class="progress-bar progress-bar-striped progress-bar-animated bg-join unidXDevolverPropor" style="width: ` + newPropor + `%"></div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                            `;


                            var totalEscan = $('.unidadesEscaenadasTotal span').html();
                            totalEscan = +totalEscan + +n[7];
                            $('.unidadesEscaenadasTotal span').html(totalEscan);

                            $(invoke).insertAfter('.readerPistolUnitBox');
                            $('.cod_' + n[6]).velocity("transition.slideUpBigIn", {
                                stagger: 250
                            });
                        }
                    }
                });
                if (isAqui == 0 && wasAqui == 0) {
                    $.growl.error({
                        message: "Los codigos de la caja no coinciden con los del pedido."
                    });
                }

                var cajasLeidas = cajasRead();
                $('.unidadesEscaenadasTotalCaja span').html(cajasLeidas.length);
            } else {
                $.growl.error({
                    message: "Esta caja no contiene productos registrados"
                });
                return;
            }

            $(document).find('#productoBoxUnitCedi').val('');
            $(document).find('#productoBoxUnitCedi').focus();
        });
    }
</script>